<?php 
if (!class_exists('galleryimages')) {

    class galleryimages extends utilities {
        private $xml_file = null;
        private $videodata_xml = null;
        private $time_diff = 1200;
        private $category_xml = null;
        private $preview_videos_xml = null;
        private $dom = null;
        
        public function __construct() {
        
        }
        
        public function setXmlFile($string) {
            $this->xml_file = $string;
        }
        
        public function load() {
            if (is_null($this->xml_file)) {
                throw new Exception('xml_file wurde nicht gesetzt');
            }
            if (!is_file($this->xml_file) || time() - filemtime($this->xml_file) > $this->time_diff) {
                // throw new Exception($this->xml_file. ' ist nicht aktuell');
                self::loadCategoryXml();
                self::loadPreviewVideosXml();
                self::createXmlFile();
            }
            $this->videodata_xml = simplexml_load_file($this->xml_file);
        }
        
        public function getVideodataXml() {
            return $this->videodata_xml;
        }
        
        private function loadCategoryXml() {
            global $CONFIG,$docroot;
            $temp_directory = $docroot.$CONFIG['TEMPDIR'];
            $category_xml_file = $temp_directory.'kategorie-'.$CONFIG['STARTKATEGORIE'].'.xml';
            if (!is_file($category_xml_file)) {
                throw new Exception($category_xml_file.' wurde nicht gefunden');
            }
            if(!$this->category_xml = @simplexml_load_file($category_xml_file)){
            	throw new Exception($category_xml_file. ' konnte nicht mit simplexml geladen werden');
            };
            // myecho($this->category_xml);
        }
        
        private function loadPreviewVideosXml() {
            global $CONFIG;
            $host = 'mm.7-7-7-partner.com';
            // $loc = '_xml/videobanner/category_'.$CONFIG['STARTKATEGORIE'].'.xml';
            $loc = '_xml/videobanner/camsonvideo.de.xml';
            $preview_video_xml_file = 'http://'.$host.'/'.$loc;
            // $this->preview_videos_xml = simplexml_load_file($preview_video_xml_file);
            if (parent::head($host, $loc)) {
                $this->preview_videos_xml = simplexml_load_file($preview_video_xml_file);
            }
            // myecho($this->preview_videos_xml);die();
        }
        
        private function createXmlFile() {
            global $CONFIG,$docroot;
            //myecho($CONFIG);die();
            $dom = new DOMDocument('1.0', 'utf-8');
            $dom->preserveWhiteSpace = false;
            $dom->formatOutput = true;
            $root = $dom->createElement('galleries');
            foreach ($this->category_xml as $item) {
                // myecho($item);
                $append = false;
                $id = (int) $item->id;
                $sedcard_xml_file = $docroot.$CONFIG['TEMPDIR'].$id.'.xml';
                $sedcard_xml = simplexml_load_file($sedcard_xml_file);
                if (self::savePreviewPics($sedcard_xml->previewpics->preview)) {
                    $elem_previewpics = $dom->createElement('previewpics');
                    $n = count($sedcard_xml->previewpics->preview);
					$a = 0;
                    for ($i = 0; $i < $n; $i++) {
                        $preview = (string) $sedcard_xml->previewpics->preview[$i];
                        $picid = image_id($preview);
                        $preview_pic = $docroot.$CONFIG['IMAGEDIR'].$picid.'.jpg';
                        if (is_file($preview_pic)) {
                            $sizes = getimagesize($preview_pic);
                            $width = $sizes[0];
                            $height = $sizes[1];
                            if ($width == 752 && $height == 564) {
                               $a++;
                            }
                        }
                        $elem_preview = $dom->createElement('preview');
                        $elem_preview->setAttribute('width', $width);
                        $elem_preview->setAttribute('height', $height);
                        $preview = $dom->createTextNode($picid);
                        $elem_preview->appendChild($preview);
                        $elem_previewpics->appendChild($elem_preview);
                    }
					if($a == $i){
						$append = true;
					}
                }
                // Vorschaubilder sind width = 752, height = 564
                if ($append) {
                    $child = $dom->createElement('gallery');
                    $elem_camid = $dom->createElement('camid');
                    $elem_camid->appendChild($dom->createTextNode($id));
                    $elem_name = $dom->createElement('name');
                    $elem_name->appendChild($dom->createCDataSection(trim((string) $item->name)));
                    $elem_description = $dom->createElement('description');
                    $elem_description->appendChild($dom->createCDataSection(trim((string) $item->description)));
                    $elem_videodata = $dom->createElement('videodata');
                    $sql = '//camonvideo/camid[.='.$id.']/parent::*';
                    // myecho($sql);
                    $result = $this->preview_videos_xml->xpath($sql);
                    if (is_array($result)) {
                        // myecho($result);
                        foreach ($result as $entry) {
                            // myecho($entry);
                            foreach ($entry as $key=>$value) {
                                // myecho((string) $value);
                                switch ($key) {
                                    case 'ccid':
                                    case 'clippreviewid':
                                    case 'tmpfilename':
                                        $value = (string) $value;
                                        $k = $dom->createElement($key);
                                        $k->appendChild($dom->createTextNode($value));
                                        $elem_videodata->appendChild($k);
                                    default:
                                }
                            }
                        }
                    }
                    $child->appendChild($elem_camid);
                    $child->appendChild($elem_name);
                    $child->appendChild($elem_description);
                    $child->appendChild($elem_previewpics);
                    $child->appendChild($elem_videodata);
                    $root->appendChild($child);
                }
            }
            $dom->appendChild($root);
            $dom->save($this->xml_file);
        }
        
        private function savePreviewPics($preview_urls) {
            $array_preview_urls = array();
            foreach ($preview_urls as $url) {
                $array_preview_urls[] = (string) $url;
            }
            // myecho($array_preview_urls);die();
            return save_preview_images($array_preview_urls);
        }

        
    }
}
?>
