<?php 
/*****************************************************
 *                                                   *
 *  777Script Version 8.1                            *
 *  image.php V. 1.0                                 *
 *  Diese Datei sollte nicht veraendert werden.      *
 *                                                   *
 *****************************************************/

// Einbinden der Config. muss ggf. angepasst werden, wenn sich die
// config.inc.php woanders befindet oder einen anderen Namen hat.
require_once ("../config.inc.php");
require_once ("../_system/autoload.inc.php");
require_once ("../_system/scripthelper.inc.php");

if ($CONFIG['PATH'] == "/") {
    $CONFIG['PATH'] = "";
}

$url = $_SERVER["REQUEST_URI"];

// Reduziere die $url auf den Teil nach $CONFIG[PATH]
$url = substr($url, 1 + strlen($CONFIG['PATH']));
$bild_id = get_image_id($url);
// myecho($bild_id);

if ($bild_id < 0) {
    // Nimm die URL auseinander
    $url_teile = explode("/", $url);
    
    // Durchsuche alle Teile nach der ID
    for ($n = 0; $n < count($url_teile); $n++) {
        if ($bild_id == -1)
            $bild_id = test_bild($url_teile[$n], $n);
    }
}

if ($bild_id < 0) {
    $error = $url.' Keine BildId gefunden';
    savelog($error);
    die($error);
}
$sizes = get_image_sizes($url);
$width = $sizes['width'];
$height = $sizes['height'];
if($width >= 752 || $height >= 564){
	$width = 752;
	$height = 564;
}
if ($CONFIG['SAVEIMAGES'] == 1) {

    if ($width != 752 && $height != 564) {
        $thumbnails_directory = $CONFIG['THUMBSDIR'];
        if (!is_dir($thumbnails_directory)) {
            $error = $thumbnails_directory.' Bitte mit Schreibrechten (777 oder 755 je nach Servereinstellung) anlegen';
            savelog($error);
            die($error);
        }
        $image = $thumbnails_directory."{$bild_id}_{$width}x{$height}.jpg";
    } else {
        $image = "{$bild_id}.jpg";
    }    
    // myecho($image);
    // Wenn das Bild existiert:
    if (file_exists($image)) {
        if (substr($config_path, strlen($config_path)) !== '/') {
            $config_path .= '/';
        }
        //header("Location: {$config_path}{$image}", true, 307);
        //die();
        header("Content-Type: image/jpeg");
        header("HTTP/1.0 200 OK");
        header("Content-Transfer-Encoding: binary");
        echo(file_get_contents($image));
    } else {
        // nachsehen ob das Bild in Originalgroesse vorliegt
        $image_original = $bild_id.".jpg";
        if (!is_file($image_original)) {
            $remote_image = $bild_id."_752x564.jpg";
            // myecho($remote_image);
            $host = 'mm.7-7-7-partner.com';
            $loc = '/images/'.$remote_image;
            $remote = 'https://'.$host.$loc;
            // echolink($remote);
            // erst nachsehen ob das Bild auf remote vorhanden ist
            if (!utilities::head($host, $loc)) {
            	$remote_image = str_ireplace('752x564', '320x240', $remote_image);
				// myecho($remote_image);
                $remote = 'https://'.$host.'/images/404picture.php?url=%2Fimages%2F'.$remote_image;
            }
			// echolink($remote);
            $picturedata = get_content($remote);
            if (strlen(trim($picturedata)) > 6 && strtoupper(bin2hex(substr($picturedata, 0, 6))) == "326232310D0A") {
                $picturedata = substr($picturedata, 6);
            }
            if (strlen(trim($picturedata)) == 0) {
                $error = $remote_image.' konnte nicht geholt werden';
                savelog($error);
                die($error);
            }
            $phandle = fopen($image_original, "w");
            if ($phandle) {
                fwrite($phandle, $picturedata);
                fclose($phandle);
		@chmod($image_original, 0666);
            }
        }
        if ($width != 752 && $height != 564) {
            try {
		$sizes = getimagesize($image_original);
		$image_width = $sizes[0];
		$image_height = $sizes[1];
		if($image_width >= $width && $image_height >= $height){
			// Bild verkleinern und dann ausgeben
			$thumbnail_file = $image;
			$thumbnailcreator = new thumbnailcreator($image_original, '');
			$thumbnailcreator->readImage();
			$thumbnailcreator->createThumbnail($width, $height, $thumbnail_file);
			$thumbnailcreator->createHeader();
			$picture_data = file_get_contents($thumbnail_file);
			if (isset($thumbnailcreator)) {
				unset($thumbnailcreator);
			}
		}else{
			$picture_data = file_get_contents($image_original);
		}
		if(!headers_sent()){
			header("Content-Type: image/jpeg");
			header("HTTP/1.0 200 OK");
			header("Content-Transfer-Encoding: binary");
		}
		echo($picture_data);
            }
            catch(exception $e) {
                $error = $e->getMessage();
                savelog($error);
                die($error);
            }
        } else {
            header("Content-Type: image/jpeg");
            header("HTTP/1.0 200 OK");
            header("Content-Transfer-Encoding: binary");
	    if(isset($picturedata)){
		echo($picturedata);
	   }else{
		echo(file_get_contents($image_original));
	   }
        }
    }
} else {
    // Bild von mm.777partner anzeigen
	if($width <= 100){
		$remote_image = $bild_id."_100x75.jpg";
	}
    elseif ($width > 100 && $width <= 140) {
        $remote_image = $bild_id."_137x102.jpg";
    } else {
        $remote_image = $bild_id."_320x240.jpg";
    }
    $url = "https://mm.7-7-7-partner.com/images/404picture.php?url=%2Fimages%2F".$remote_image;
    header('Location: '.$url, true, 301);
}
exit();
?>
