<?php
/**
 * BASICS zur Ausfuehrung der
 * remotelogin.php
 * remoteregister.php
 * remotepassword.php
 *
 * moegliche RequestParameter:
 *
 * @param id 		entspricht der Webmaster oder Projektid
 * @param camid 	entspricht der Senderid
 * @param email     entspricht der Emailadresse es Users
 * @param name      entspricht den Namen des Users
 * @param language	entspricht der Sprache in der die Seite angezeigt werden soll
 * @param l         entspricht dem layout welches von 777livecams angezeigt werden soll
 * @param sc_id     entspricht der ID einer bestimmten Kategorie 
 * @param h         entspricht     h = off es wird kein Header (Produktlogo) angezeigt
 * @param targeturl entspricht der URL auf die in 777livecams umgelseitet werden soll
 *
 * 2017-03-30
 *
 */

if (!headers_sent() && !isset($_SESSION)) {
	session_start();
}

if (!function_exists('setLanguage')) {
	function setLanguage() {
		global $CONFIG;
		$CONFIG['LANGUAGE'] = 'de';
		$valid = false;
		$languages = array('de', 'en');
		$language = null;
		if (isset($_SESSION['culture'])) {
			$_SESSION['LANGUAGE'] = $_SESSION['culture'];
		}
		if (isset($_SESSION['LANGUAGE']) && !empty($_SESSION['LANGUAGE'])) {
			$language = $_SESSION['LANGUAGE'];
			$valid = true;
		} else {
			// evtl. Browsererkennung
			$_HTTP_ACCEPT_LANGUAGE = isset($_SERVER['HTTP_ACCEPT_LANGUAGE']) ? $_SERVER['HTTP_ACCEPT_LANGUAGE'] : $CONFIG['LANGUAGE'];
			if (strpos($_HTTP_ACCEPT_LANGUAGE, '-') !== false) {
				// language teilen
				$_HTTP_ACCEPT_LANGUAGE = preg_split('/-/', $_SERVER['HTTP_ACCEPT_LANGUAGE']);
				$_HTTP_ACCEPT_LANGUAGE = $_HTTP_ACCEPT_LANGUAGE[0];
			}
			foreach ($languages as $l) {
				if ($l == strtolower($_HTTP_ACCEPT_LANGUAGE)) {
					$language = $l;
					$valid = true;
					break;
				}
			}
		}
		if (key_exists('language', $_REQUEST) || key_exists('culture', $_REQUEST) || key_exists('setup_language', $_REQUEST)) {
			try {
				if (key_exists('setup_language', $_REQUEST)) {
					$request_language = $_REQUEST['setup_language'];
				}
				if (key_exists('language', $_REQUEST)) {
					$request_language = $_REQUEST['language'];
				}
				if (key_exists('culture', $_REQUEST)) {
					$request_language = $_REQUEST['culture'];
				}
				if (!in_array($request_language, $languages)) {
					//throw new Exception($_REQUEST['language'].' ist keine vom System akzeptierte Sprache');
					$valid = false;
				} else {
					$language = $request_language;
					$valid = true;
				}
			} catch(Exception $e) {
				die($e -> getMessage());
			}
		}
		if ($valid) {
			$_SESSION['culture'] = $_SESSION['LANGUAGE'] = $CONFIG['LANGUAGE'] = $language;
		} else {
			$_SESSION['culture'] = $_SESSION['LANGUAGE'] = $CONFIG['LANGUAGE'] = 'de';
		}
		return $valid;
	}
}

$form = $language['de'] = $language['en'] = array();

global $CONFIG;
if(!isset($CONFIG) || !is_array($CONFIG)){
	$CONFIG = array();	
}
$CONFIG['CAMID'] = $CONFIG['SC_ID'] = null;
// language aus browsereinstellung auslesen
if (!setLanguage()) {
	$CONFIG['LANGUAGE'] = 'de';
}
if(!isset($CONFIG['WMID'])){
	$CONFIG['WMID'] = 'A10000';	
}

if(!isset($CONFIG['LIVECAMLAYOUT'])){
	$CONFIG['LIVECAMLAYOUT'] = 'redrose';
}

if(!isset($CONFIG['HEADER'])){
	$CONFIG['HEADER'] = null;
}

if (key_exists('l', $_REQUEST)) {
	$CONFIG['LIVECAMLAYOUT'] = $_REQUEST['l'];
}

if (key_exists('layout', $_REQUEST)) {
	$CONFIG['LIVECAMLAYOUT'] = $_REQUEST['layout'];
}

if (key_exists('h', $_REQUEST) && $_REQUEST['h'] == 'off') {
	$CONFIG['HEADER'] = $_REQUEST['h'];
}

if (key_exists('header', $_REQUEST) && $_REQUEST['header'] == 'off') {
	$CONFIG['HEADER'] = $_REQUEST['header'];
}

if (key_exists('bid', $_REQUEST) && preg_match('/^([AP][0-9]{1,9})$/', $_REQUEST['bid'])) {
    $CONFIG['WMID'] = $_REQUEST['bid'];
}

if (key_exists('id', $_REQUEST) && preg_match('/^([AP][0-9]{1,9})$/', $_REQUEST['id'])) {
    $CONFIG['WMID'] = $_REQUEST['id'];
}

if (key_exists('camid', $_REQUEST) && preg_match('/^([0-9]{1,6})$/', $_REQUEST['camid']) && $_REQUEST['camid'] > 0) {
	$CONFIG['CAMID'] = $_REQUEST['camid'];
}

if (key_exists('sc_id', $_REQUEST) && preg_match('/^([0-9]|1[0-1]|1[3-9])$/', $_REQUEST['sc_id'])) {
	$CONFIG['SC_ID'] = $_REQUEST['sc_id'];
}

$raw_targeturl = "/index.php?l={$CONFIG['LIVECAMLAYOUT']}&id={$CONFIG["WMID"]}";
if (!is_null($CONFIG['CAMID'])) {
	$raw_targeturl .= "&camid={$CONFIG['CAMID']}";
}

if (!is_null($CONFIG['SC_ID']) && is_null($CONFIG['CAMID'])) {
	$raw_targeturl .= "&sc_id={$CONFIG['SC_ID']}";
}

if (!is_null($CONFIG['HEADER'])) {
	$raw_targeturl .= "&h={$CONFIG['HEADER']}";
}

if ($CONFIG['LANGUAGE'] != 'de') {
	$raw_targeturl .= "&setup_language={$CONFIG['LANGUAGE']}";
}

$targeturl = urlencode(base64_encode($raw_targeturl));
$targeturl64 = base64_encode($raw_targeturl);

// errorcode
if (isset($_REQUEST['errorcode'])) {
	$errorcode = $_REQUEST['errorcode'];
}
// sendto:
$action = array();
$action['remotecaptcha'] = "https://777livecams.com/remotecaptcha.php";
$action['remoteregister'] = "https://777livecams.com/remoteregister.php";
$action['remotelogin'] = "https://777livecams.com/remotelogin.php";
$action['remotepassword'] = "https://777livecams.com/remotepassword.php";

if ($CONFIG['LANGUAGE'] == "") {
	$systemtext = $language['de'];
} else {
	$systemtext = $language[$CONFIG['LANGUAGE']];
}

$usepixel = false;
$counterpixel = '';
if (stripos($_SERVER['HTTP_USER_AGENT'], "googlebot") === false) {
	if (!key_exists('cid_refresh', $_SESSION)) {
		$usepixel = true;
	} else if ((time() - 60) >= $_SESSION['cid_refresh']) {
		$usepixel = true;
	}
}
if ($usepixel) {
	$_SESSION['cid_refresh'] = time();
	$queryString = '?webid=' . $CONFIG['WMID'];
	// Website-ID uebergeben..?
	$queryString .= '&amp;websiteid=2';
	$queryString .= '&amp;session=' . session_id();
	$counterurl = "https://counter.live4members.com/";

	$counterpixel = '<img src="' . $counterurl . $queryString . '" id="counter.live4members" alt="counter" style="width:1px;height:1px;display:none;visibility:hidden;"/>';
}
// end counterpixel

// Wenn es die remoteregister oder remotepasswort ist
// Dann hole auch das Captcha
$remoteregister = $remotepassword = false;

if (strpos($_SERVER['REQUEST_URI'], 'remoteregister.php') !== false) {
	$remoteregister = true;
}

if (strpos($_SERVER['REQUEST_URI'], 'remotepassword.php') !== false) {
	$remotepassword = true;
}

if ($remoteregister || $remotepassword) {
	$captcha_full = file_get_contents($action['remotecaptcha']);
	$captcha['uniquekey'] = $captcha_full;
	$form['capid'] = $captcha['uniquekey'];
}

$form['bid'] = $CONFIG['WMID'];
$form['layout'] = $CONFIG['LIVECAMLAYOUT'];
$form['language'] = $CONFIG['LANGUAGE'];
$form['origin'] = "//" . $_SERVER['HTTP_HOST'] . substr($_SERVER['SCRIPT_NAME'], 0, strripos($_SERVER['SCRIPT_NAME'], '/'));
$form['origin'] .= $_SERVER['REQUEST_URI']; 
$form['ref'] = 'script';
$form['sc_id'] = $CONFIG['SC_ID'];

$form_names = array('email', 'camid', 'name');
foreach ($form_names as $form_name) {
	if (key_exists($form_name, $_REQUEST)) {
		$form[$form_name] = $_REQUEST[$form_name];
	} else {
		$form[$form_name] = '';
	}
}

if ($remoteregister || $remotepassword) {
	$captcha_full = file_get_contents($action['remotecaptcha']);
	$captcha['uniquekey'] = $captcha_full;
	$form['capid'] = $captcha['uniquekey'];
}

$targeturl = $form['targeturl'] =  $targeturl64;

// querystring for remotelogin
$form['remotelogin_querystring'] = '?l=' . $CONFIG['LIVECAMLAYOUT'] . '&amp;id=' . $CONFIG['WMID'];
// querystring for remotepassword
$form['remotepassword_querystring'] = '?bid=' . $form['bid'] . '&amp;targeturl=' . $form['targeturl'] . '&amp;language=' . $form['language'] . '&amp;l=' . $CONFIG['LIVECAMLAYOUT'];
// querystring for remoteregister
$form['remoteregister_querystring'] = '?bid=' . $form['bid'] . '&amp;targeturl=' . $form['targeturl'] . '&amp;language=' . $form['language'] . '&amp;l=' . $CONFIG['LIVECAMLAYOUT'];

if (!is_null($CONFIG['CAMID'])) {
	$form['remotelogin_querystring'] .= '&amp;show=' . $CONFIG['CAMID'];
	$form['remotepassword_querystring'] .= '&amp;camid=' . $CONFIG['CAMID'] . '&amp;name=' . urlencode($form['name']);
	$form['remoteregister_querystring'] .= '&amp;camid=' . $CONFIG['CAMID'] . '&amp;name=' . urlencode($form['name']);
}
if (!is_null($CONFIG['SC_ID']) && is_null($CONFIG['CAMID'])) {
	$form['remotelogin_querystring'] .= '&amp;sc_id=' . $CONFIG['SC_ID'];
	$form['remotepassword_querystring'] .= '&amp;sc_id=' . $CONFIG['SC_ID'];
	$form['remoteregister_querystring'] .= '&amp;sc_id=' . $CONFIG['SC_ID'];
}
if (!is_null($CONFIG['HEADER'])) {
	$form['remotelogin_querystring'] .= '&amp;h=' . $CONFIG['HEADER'];
	$form['remotepassword_querystring'] .= '&amp;h=' . $CONFIG['HEADER'];
	$form['remoteregister_querystring'] .= '&amp;h=' . $CONFIG['HEADER'];
}
if ($CONFIG['LANGUAGE'] != 'de') {
	$form['remotelogin_querystring'] .= '&amp;setup_language=' . $CONFIG['LANGUAGE'];
	$form['remotepassword_querystring'] .= '&amp;setup_language=' . $CONFIG['LANGUAGE'];
	$form['remoteregister_querystring'] .= '&amp;setup_language=' . $CONFIG['LANGUAGE'];
}
// CSS und Images
$imagepath = $imagepath_for_javascript = 'images_' . $CONFIG['LANGUAGE'] . '/';
$imagepath = urlencode($imagepath);

// Bei Einbindung in 777Script
if (isset($CONFIG['PATH']) && isset($CONFIG['POPUPDIR'])) {
	if (substr($CONFIG['PATH'], strlen($CONFIG['PATH']) - 1) != '/') {
		$CONFIG['PATH'] .= '/';
	}
	if (substr($CONFIG['POPUPDIR'], strlen($CONFIG['POPUPDIR']) - 1) != '/') {
		$CONFIG['POPUPDIR'] .= '/';
	}
	$popupdir = $CONFIG['PATH'] . $CONFIG['POPUPDIR'];
	$popupdir = str_replace('//', '/', $popupdir);
	$imagepath = $imagepath_for_javascript = $popupdir . 'images_' . $CONFIG['LANGUAGE'] . '/';
	$imagepath = urlencode($imagepath);

}

// texte
include_once ('texte_' . $CONFIG['LANGUAGE'] . '.php');
if(!headers_sent()){
	header('Content-type: text/html; charset=UTF-8');
}
?>
